package com.qmth.teachcloud.common.bean.dto.excel;

import com.qmth.teachcloud.common.annotation.ExcelImportTempleteVaild;
import com.qmth.teachcloud.common.annotation.ExcelNote;
import com.qmth.teachcloud.common.annotation.ExcelProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @Description: 基础课程数据导入类
 * @Author: CaoZixuan
 * @Date: 2021-08-06
 */
@ExcelImportTempleteVaild(value = true)
public class BasicCourseImportDto implements Serializable {

    @ExcelNote(value = "课程名称")
    @ExcelProperty(name = "课程名称", width = 30, index = 1)
    @NotNull
    private String courseName;

    @ExcelNote(value = "课程编码")
    @ExcelProperty(name = "课程编码", width = 30, index = 2)
    @NotNull
    private String courseCode;

    @ExcelNote(value = "开课学院")
    @ExcelProperty(name = "开课学院", width = 30, index = 3)
    @NotNull
    private String teachingRoomName;

    @ExcelNote(value = "授课班级")
    @ExcelProperty(name = "授课班级", width = 30, index = 4)
    private String clazz;

    @ExcelNote(value = "姓名")
    @ExcelProperty(name = "姓名", width = 30, index = 5)
    private String name;

    @ExcelNote(value = "用户名/工号")
    @ExcelProperty(name = "用户名/工号", width = 30, index = 6)
    private String code;

    @ApiModelProperty("行索引")
    private Integer rowIndex;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getTeachingRoomName() {
        return teachingRoomName;
    }

    public void setTeachingRoomName(String teachingRoomName) {
        this.teachingRoomName = teachingRoomName;
    }

    public String getClazz() {
        return clazz;
    }

    public void setClazz(String clazz) {
        this.clazz = clazz;
    }

    public Integer getRowIndex() {
        return rowIndex;
    }

    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }
}
