package com.qmth.teachcloud.mark.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.teachcloud.common.bean.dto.DataPermissionRule;
import com.qmth.teachcloud.mark.bean.archivescore.*;
import com.qmth.teachcloud.mark.bean.scananswer.AnswerQueryDomain;
import com.qmth.teachcloud.mark.bean.scananswer.AnswerQueryVo;
import com.qmth.teachcloud.mark.bean.student.StudentQuery;
import com.qmth.teachcloud.mark.bean.student.StudentVo;
import com.qmth.teachcloud.mark.dto.UnexistStudentDto;
import com.qmth.teachcloud.mark.dto.mark.score.StudentScoreDetailDto;
import com.qmth.teachcloud.mark.entity.MarkStudent;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 考试考生库 Mapper 接口
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface MarkStudentMapper extends BaseMapper<MarkStudent> {

	IPage<StudentScoreDetailDto> pageStudentScore(@Param("page") Page<StudentScoreDetailDto> page,
												  @Param("examId") Long examId, @Param("paperNumber") String paperNumber, @Param("college") String college,
												  @Param("className") String className, @Param("teacher") String teacher, @Param("filter") Integer filter,
												  @Param("absent") Boolean absent, @Param("breach") Boolean breach, @Param("startScore") Double startScore,
												  @Param("endScore") Double endScore, @Param("subScore") Double subScore,
												  @Param("objectiveScoreLt") Double objectiveScoreLt, @Param("studentName") String studentName,
												  @Param("studentCode") String studentCode, @Param("orderType") String orderType, @Param("orderField") String orderField);

	List<MarkStudent> listAbsentOrBreachMarkTaskStudent(@Param("examId") Long examId,
			@Param("paperNumber") String paperNumber);

	IPage<MarkStudent> listUnMarkTaskStudent(@Param("page") Page<MarkStudent> page, @Param("examId") Long examId,
			@Param("paperNumber") String paperNumber, @Param("groupNumber") Integer groupNumber);

	StudentVo findOne(@Param("query") StudentQuery query);

	IPage<AnswerQueryVo> queryPage(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query, @Param("dpr") DataPermissionRule dpr);

	List<String> querySummary(@Param("query") AnswerQueryDomain query, @Param("dpr") DataPermissionRule dpr);

	List<Long> findIdByExamIdAndPaperNumberAndSubjectiveStatus(@Param("examId") Long examId,
			@Param("paperNumber") String paperNumber, @Param("unmark") String unmark, @Param("marked") String marked);

	List<ArchiveStudentVo> studentList(@Param("req") ArchiveStudentQuery query);

	OverViewVo overview(@Param("examId") Long examId, @Param("paperNumber") String paperNumber);

	int getCountByScoreRange(@Param("examId") Long examId, @Param("paperNumber") String paperNumber,
			@Param("start") Double start, @Param("end") Double end);

	List<CollegeVo> college(@Param("examId") Long examId, @Param("paperNumber") String paperNumber);
	List<ClassVo> classData(@Param("examId") Long examId, @Param("paperNumber") String paperNumber);
	List<TeacherVo> teacher(@Param("examId") Long examId, @Param("paperNumber") String paperNumber);

    List<UnexistStudentDto> listUnexistStudentByExamIdAndCoursePaperId(@Param("examId") Long examId);

	IPage<ArchiveStudentVo> studentList(@Param("page") Page<ArchiveStudentVo> page, @Param("req") ArchiveStudentQuery query);

	List<TeacherClassVo> teacherClass(@Param("examId") Long examId, @Param("paperNumber") String paperNumber);

    int selectCountByQuery(@Param("markStudent") MarkStudent markStudent, @Param("dpr") DataPermissionRule dpr);
}
