package com.qmth.teachcloud.mark.mapper;

import java.util.List;

import com.qmth.teachcloud.common.bean.dto.DataPermissionRule;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qmth.teachcloud.mark.dto.ScanStudentDto;
import com.qmth.teachcloud.mark.entity.ScanOmrTask;
import com.qmth.teachcloud.mark.enums.OmrTaskStatus;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface ScanOmrTaskMapper extends BaseMapper<ScanOmrTask> {

	List<ScanOmrTask> findUnMarked(@Param(value = "examId") Long examId, @Param(value = "pageNumber") int pageNumber,
			@Param(value = "pageSize") int pageSize, @Param(value = "status") OmrTaskStatus status);

	List<ScanStudentDto> listByExamIdAndStatusAndUserId(@Param(value = "examId") Long examId,
			@Param(value = "status") OmrTaskStatus status, @Param(value = "userId") Long userId);

	int getStudentCountByExamAndStatusAndUserId(@Param(value = "examId") Long examId,
			@Param(value = "userId") Long userId, @Param(value = "status") OmrTaskStatus status);

	int getStudentCountByExamAndStatus(@Param(value = "examId") Long examId,
			@Param(value = "status") OmrTaskStatus status);

    int countOmrTask(@Param("scanOmrTask") ScanOmrTask scanOmrTask, @Param("dpr") DataPermissionRule dpr);
}
