package com.qmth.teachcloud.mark.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.teachcloud.common.bean.dto.DataPermissionRule;
import com.qmth.teachcloud.common.enums.scan.ConditionType;
import com.qmth.teachcloud.mark.dto.ScanOmrStudent;
import com.qmth.teachcloud.mark.dto.ScanOmrTaskResultDto;
import com.qmth.teachcloud.mark.dto.ScanOmrTaskSaveDto;
import com.qmth.teachcloud.mark.dto.ScanOmrTaskStatusDto;
import com.qmth.teachcloud.mark.dto.ScanStudentDto;
import com.qmth.teachcloud.mark.entity.ScanOmrTask;
import com.qmth.teachcloud.mark.enums.OmrTaskStatus;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface ScanOmrTaskService extends IService<ScanOmrTask> {
	
	ScanOmrTask buildTask(ConditionType c, Long studentId);

	ScanOmrStudent getTask(Long studentId);

	ScanOmrTaskSaveDto submitTask(List<ScanOmrTaskResultDto> result, Long userId);

	ScanOmrTaskStatusDto getStatus(Long examId, Long userId);

	int getFinishStudentCountByExamAndUserId(Long examId, Long userId);

	int getTodoStudentCountByExam(Long examId);

	void deleteByStudentId(Long examId, Long studentId);

	int getCount(Long examId, OmrTaskStatus status, String courseCode, String coursePaperId, DataPermissionRule dpr);

	List<ScanStudentDto> list(Long examId, OmrTaskStatus status, Long userId);

	void saveTask(Long studentId);

}
