package com.qmth.teachcloud.task.enums;

import java.util.Objects;

/**
 * @Description: job enum
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/3/31
 */
public enum JobEnum {

    RESET_CREATE_PDF_JOB("重新生成pdf定时任务"),

    RESET_CREATE_PDF_JOB_GROUP("重新生成pdfjob组"),

    SMS_NOTICE_TASK_EXPIRE_JOB("任务到期提醒定时任务"),

    SMS_NOTICE_TASK_EXPIRE_JOB_GROUP("任务到期提醒定时任务job组"),

    SMS_NOTICE_TASK_OVERDUE_JOB("任务逾期提醒定时任务"),

    SMS_NOTICE_TASK_OVERDUE_JOB_GROUP("任务逾期提醒定时任务job组"),

    SMS_NOTICE_TASK_RESEND_JOB("短信发送失败重发定时任务"),

    SMS_NOTICE_TASK_RESEND_JOB_GROUP("短信发送失败重发定时任务job组"),

    SYNC_REUNIFY_JOB("自动统分定时任务"),

    SYNC_REUNIFY_JOB_GROUP("自动统分定时任务job组"),

    REDIS_MQ_JOB("学校信息同步定时任务"),

    REDIS_MQ_JOB_GROUP("学校信息同步定时任务组"),
    UPDATE_MARKER_QUALITY("更新评卷员质量监控指标"),
    UPDATE_MARKER_QUALITY_GROUP("更新评卷员质量监控指标任务组"),
    BUILD_MARK_TASK("创建评卷任务"),
    BUILD_MARK_TASK_GROUP("创建评卷任务任务组"),
    INIT_MARK_DATA("初始化阅卷数据"),
    INIT_MARK_DATA_GROUP("初始化阅卷数据任务组"),
    CLEAR_TIMEOUT_TASK("清空过期任务"),
    CLEAR_TIMEOUT_TASK_GROUP("清空过期任务任务组");

    private String title;

    private JobEnum(String title) {
        this.title = title;
    }

    public String getTitle() {
        return title;
    }

    /**
     * 状态转换 toName
     *
     * @param value
     * @return
     */
    public static String convertToName(String value) {
        for (JobEnum e : JobEnum.values()) {
            if (Objects.equals(value.trim(), e.getTitle())) {
                return e.name();
            }
        }
        return null;
    }
}
